MB.events = {};
MB.events.Ctrl = false;
MB.events.Shift = false;
MB.events.Alt = false;
MB.events.Tabs = {
	[1] = {
		["Size"] = 5,
		["Name"] = "Общие",
	},
	[2] = {
		["Size"] = 5,
		["Name"] = "Поверхность",
	},
	[3] = {
		["Size"] = 5,
		["Name"] = "Подземелья",
	},
	[4] = {
		["Size"] = 5,
		["Name"] = "Осады",
	},
};

function MB.events.MinimapOnUpdate( this, elapsedTime )
	MB.events.Shift = IsShiftKeyDown();
	MB.events.Ctrl = IsCtrlKeyDown();
	MB.events.Alt = IsAltKeyDown();
	if( not MB.Inited )then return nil; end;
	
	if( MB.Actions == nil )then MB.tools.LoadConfig(); end;
	
	local nTexture = this:GetNormalTexture();
	local pTexture = this:GetPushedTexture();
	
	if( MBVariables.Enabled )then
		if( MB.State == MB_STATE_NORMAL )then
			nTexture:SetTexture( "interface/addons/mautobuff/texture/minimap/normal" );
			pTexture:SetTexture( "interface/addons/mautobuff/texture/minimap/normal" );
		elseif( MB.State == MB_STATE_SAFE )then
			nTexture:SetTexture( "interface/addons/mautobuff/texture/minimap/safe" );
			pTexture:SetTexture( "interface/addons/mautobuff/texture/minimap/safe" );
		elseif( MB.State == MB_STATE_GUILDWAR )then
			nTexture:SetTexture( "interface/addons/mautobuff/texture/minimap/guildwar" );
			pTexture:SetTexture( "interface/addons/mautobuff/texture/minimap/guildwar" );
		else
			nTexture:SetTexture( "interface/addons/mautobuff/texture/minimap/combat" );
			pTexture:SetTexture( "interface/addons/mautobuff/texture/minimap/combat" );
		end;
	else
		nTexture:SetTexture( "interface/addons/mautobuff/texture/minimap/disable" );
		pTexture:SetTexture( "interface/addons/mautobuff/texture/minimap/disable" );
	end;

	if( GetPlayerCombatState() )then
		if( MBVariables.ShowInCombatTime )then
			if( MBVariables.InCombatTimeOnBossOnly )then
				if( UnitSex( "target" ) > 2 )then
					MBTimeFrame.CloseMe = false;
					MBTimeFrame:Show();
				end;
			else
				MBTimeFrame.CloseMe = false;
				MBTimeFrame:Show();
			end;
		end;
		_G[ this:GetName() .. "FlashFrame" ]:Show();
	else
		if( MBVariables.ShowInCombatTime )then
			if( MBTimeFrame.Timer ~= nil )then
				MB.Message( "Бой длился " .. MBTimeFrameText:GetText() .. " минут" );
				MBTimeFrame.Timer = nil;
			end;
		end;
		_G[ this:GetName() .. "FlashFrame" ]:Hide();
		MBTimeFrame.CloseMe = true;
	end;
	if( MBVariables.AbilityFrame )and( not MBAbilities:IsVisible() )then
		MBAbilities:Show();
	end;
end;

function MB.events.OnLoad( this )
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("SAVE_VARIABLES");
	this:RegisterEvent("ZONE_CHANGED");
	this:RegisterEvent("EXCHANGECLASS_SUCCESS");
	this:RegisterEvent("LOADING_END");
end;

function MB.events.OnEvent( this, event )
	if( event == "VARIABLES_LOADED" )then
		MB.events.VariablesLoaded();
	elseif( event == "EXCHANGECLASS_SUCCESS" )then
		MB.Actions = nil;
	elseif( event == "ZONE_CHANGED" )then
		local ZoneID = GetZoneID();
		if( ZoneID <= 80 )or( ZoneID > 1000 )then
			MB.State = MB_STATE_NORMAL;
		elseif( MLib.tableContains( MBVariables.SafeZones, ZoneID ) )then
			MB.State = MB_STATE_SAFE;
		elseif( MLib.tableContains( MBVariables.NoBuffDungeons, ZoneID ) )then
			MB.State = MB_STATE_NORMAL;
		elseif( ZoneID == 402 )or( ZoneID == 410 )or( ZoneID == 411 )or( ZoneID == 430 )then
			MB.State = MB_STATE_GUILDWAR;
		else
			MB.State = MB_STATE_DUNGEON;
		end;
	elseif( event == "LOADING_END" )then
		local page = "MBConfigFramePage1";
		_G[ page .. "BuffWarnDesc" ]:SetText( "Критическое время для обновления" );
		_G[ page .. "BuffWarn" ]:SetValueStepMode("INT");
		_G[ page .. "BuffWarn" ]:SetMinMaxValues( 5, 15 );
		_G[ page .. "BuffWarnLow" ]:SetText( "5" );
		_G[ page .. "BuffWarnHigh" ]:SetText( "15" );
		_G[ page .. "BuffWarn" ]:SetValue( MBVariables.BuffWarning );
		_G[ page .. "BuffWarnValue" ]:ClearAllAnchors();
		_G[ page .. "BuffWarnValue" ]:SetAnchor( "TOPLEFT", "TOPRIGHT", "$parent", 7, 1 );
		
		MB.tools.LoadConfig();
		MB.events.PlaceAbilityFrame();
	end;
end;

function MB.events.VariablesLoaded()
	local hRet;
	hRet, MBVariables = MLib.CheckVariables( MBVariables, MB.DefaultConfig );
	if( hRet == MLIB_CHECKVARIABLES_FAILED )then
		MB.Message( "|cffFF0000Ошибка запуска! Исполнение прекращено!|r" );
		MB.PANIC = true;
		return nil;
	end;
	SaveVariables("MBVariables");
	
	local _scale = GetUIScale();
	if( MBVariables.TimeFrame == nil )then
		MBVariables.TimeFrame = {};
		MBVariables.TimeFrame.PositionX = 300;
		MBVariables.TimeFrame.PositionY = 200;
	end;
	MBTimeFrame:ClearAllAnchors();
	MBTimeFrame:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, MBVariables.TimeFrame.PositionX / _scale, MBVariables.TimeFrame.PositionY / _scale );
	MBTimeFrame.Timer = 0;
	
	MB.Inited = true;
end;

function MB.events.PlaceAbilityFrame()
	local _scale = GetUIScale();
	MBAbilities:ClearAllAnchors();
	MBAbilities:SetAnchor( "TOPLEFT", "TOPLEFT", UIParent, MBVariables.AbilityFramePosition.X / _scale, MBVariables.AbilityFramePosition.Y / _scale );
	
	MBAbilitiesAnchor:GetNormalTexture():SetColor( 1, 0.6, 0 );
	MBAbilitiesAnchor:GetPushedTexture():SetColor( 1, 0.6, 0 );
	MBAbilitiesAnchor:SetAlpha( 0.2 );
	
	local parent = "MBConfigFrame" .. "Page1" .. "Abilities";
	for n = 1, 24 do
		if( _G[ parent .. n ] ~= nil )then
		
		_G[ parent .. n .. "Title" ]:SetText( MB.AbilityName[ n ] );
		_G[ parent .. n ]:SetChecked( MB.Abilities[ n ] );
		
		end;
	end;

	_G[ parent .. "RangeTitle" ]:SetText( "Дальний бой (для физ. параметров)" );
	_G[ parent .. "Range" ]:SetChecked( MB.Abilities[ 99 ] );
	_G[ parent .. "PercentTitle" ]:SetText( "Крит и парирование только процентами" );
	_G[ parent .. "Percent" ]:SetChecked( MB.Abilities[ 100 ] );
	
	_G[ parent .. "DirectionTitle" ]:SetText( "Направление:" );
	_G[ parent .. "Direction" ].Items = { "Сверху вниз", "Снизу вверх" };
	if( MBVariables.AbilityFrameDirection == "upward" )then
		_G[ parent .. "Direction" ].ItemIndex = 2;
	else
		_G[ parent .. "Direction" ].ItemIndex = 1;
	end;
	_G[ parent .. "Direction" ].OnChange = function( this )
		if( not MB.Inited )then return nil; end;
		if( this.ItemIndex == 2 )then
			MBVariables.AbilityFrameDirection = "upward";
		else
			MBVariables.AbilityFrameDirection = "downward";
		end;
		MB.events.PlaceAbilityFrame();
	end;
	_G[ parent .. "FontSizeTitle" ]:SetText( "Размер шрифта:" );
	_G[ parent .. "FontSize" ].Items = { 11, 12, 13, 14, 15, 16, 17, 18 };
	_G[ parent .. "FontSize" ].ItemIndex = MBVariables.AbilityFrameFontSize;
	_G[ parent .. "FontSize" ].OnChange = function( this )
		if( not MB.Inited )then return nil; end;
		MBVariables.AbilityFrameFontSize = this.ItemIndex;
		MB.events.PlaceAbilityFrame();
	end;

	
	if( MBVariables.AbilityFrameDirection == "upward" )then
		local texture = MBAbilitiesAnchor:GetNormalTexture(); texture:SetTexture( "interface/addons/!mlib/texture/anchors/bottomleft.tga" );
		local texture = MBAbilitiesAnchor:GetPushedTexture(); texture:SetTexture( "interface/addons/!mlib/texture/anchors/bottomleft.tga" );
	else
		local texture = MBAbilitiesAnchor:GetNormalTexture(); texture:SetTexture( "interface/addons/!mlib/texture/anchors/topleft.tga" );
		local texture = MBAbilitiesAnchor:GetPushedTexture(); texture:SetTexture( "interface/addons/!mlib/texture/anchors/topleft.tga" );
	end;
	
	MBAbilities1:ClearAllAnchors();
	if( MBVariables.AbilityFrameDirection == "upward" )then
		MBAbilities1:SetAnchor( "BOTTOMLEFT", "BOTTOMLEFT", "$parent", 5, -5 );
	else
		MBAbilities1:SetAnchor( "BOTTOMLEFT", "BOTTOMLEFT", "$parent", 5, 5 );
	end;

	for n = 2, 23 do
		_G[ "MBAbilities" .. n ]:ClearAllAnchors();
		if( MBVariables.AbilityFrameDirection == "upward" )then
			_G[ "MBAbilities" .. n ]:SetAnchor( "BOTTOMLEFT", "TOPLEFT", "MBAbilities" .. ( n - 1 ), 0, -1 );
		else
			_G[ "MBAbilities" .. n ]:SetAnchor( "TOPLEFT", "BOTTOMLEFT", "MBAbilities" .. ( n - 1 ), 0, 1 );
		end;
	end;
end;

function MB.events.TimeFrameDrop( this )
	this:StopMovingOrSizing();
	MBVariables.TimeFrame.PositionX, MBVariables.TimeFrame.PositionY = this:GetPos();
end;

function MB.events.TimeFrameOnUpdate( this, elapsedTime )
	if( not this.CloseMe )and( this:IsVisible() )then
		this:SetAlpha( 1 );
		if( this.Timer == nil )then this.Timer = 0; end;
		this.Timer = this.Timer + elapsedTime;
		local minuts, seconds = 0, 0;
		if( this.Timer > 60 )then
			minuts = math.floor( this.Timer / 60 );
			seconds = math.floor( this.Timer % 60 );
		else
			seconds = math.floor( this.Timer );
		end;
		
		if( string.len( minuts ) < 2 )then minuts = "0" .. minuts; end;
		if( string.len( seconds ) < 2 )then seconds = "0" .. seconds; end;
		
		MBTimeFrameText:SetText( minuts .. ":" .. seconds );
		
		return nil;
	end;
	if( this.CloseMe )and( this:IsVisible() )then
		this:SetAlpha( this:GetAlpha() - 0.01 );
		if( this:GetAlpha() <= 0 )then
			this:Hide();
		end;
		MBTimeFrame.Timer = nil;
	end;
end;

function MB.events.TabButtonClick( this )
	local _id = this:GetID();
	local _parent = this:GetParent();
	PanelTemplates_SetTab( _parent, _id );
	for n = 1, #MB.events.Tabs do
		if( n ~= _id )then 
			_G[ _parent:GetName() .. "Page" .. n ]:Hide();
		else 
			_G[ _parent:GetName() .. "Page" .. n ]:Show();
		end;
	end;
	MBConfigFrame.TabIndex = _id;
end;

function MB.events.TabButtonLoad( this )
	local _tab = MB.events.Tabs[ this:GetID() ];
	this:SetText( _tab.Name );
	PanelTemplates_TabResize( this, _tab.Size );
end;

function MB.events.ConfigOnLoad(this)
	UIPanelBackdropFrame_SetTexture( this, "Interface/Common/PanelCommonFrame", 256 , 256 );
	PanelTemplates_SetNumTabs( this, #MB.events.Tabs );
	PanelTemplates_SetTab( this, 1 );
	MB.events.TabButtonClick( _G[ this:GetName() .. "Tab1" ] );

	this.HelpFunction = function()
		local NoteText = "На этой вкладке находятся общие настройки\n\n" ..
						 "Тут Вы можете установить критический предел бафа, после которого он будет обновлен," ..
						 " по умолчанию установлен предел в 10 секунд.\n\n" ..
						 "Сочетание клавиш для автобега не отменяет кнопки автобега в системе, а только расширяет функционал.\n\n" ..
						 "Исключения - это бафы (обычно от ездовых животных), при наличии которого ни одно действие не будет исполняться.";
		if( MBConfigFrame.TabIndex == 2 )then
			NoteText = "Тут создается список поддерживаемых бафов для поверхности.\n\n" ..
			           "Поверхностью считается любая зона с GUID от 1 до 80, либо подземелья, для которых поставлен флаг \"Бафы поверхности\"\n\n" ..
					   "При наведении на строку любого бафа, Вы увидите подсказку о скилле или предмете, который нужен для поддержания бафа. " ..
					   "Если подсказка не полна, а показывает только название предмета, это означает, что нужный предмет в сумке отсутствует.\n\n" ..
					   "Режим поверхность/подземелье/осадные войны так же можно переключить в контекстном меню кнопки миникарты аддона.";
		end;
		if( MBConfigFrame.TabIndex == 3 )then
			NoteText = "Тут создается список поддерживаемых бафов для подземелья.\n\n" ..
					   "При наведении на строку любого бафа, Вы увидите подсказку о скилле или предмете, который нужен для поддержания бафа. " ..
					   "Если подсказка не полна, а показывает только название предмета, это означает, что нужный предмет в сумке отсутствует.\n\n" ..
					   "Режим поверхность/подземелье/осадные войны так же можно переключить в контекстном меню кнопки миникарты аддона.";
		end;
		if( MBConfigFrame.TabIndex == 4 )then
			NoteText = "Тут создается список поддерживаемых бафов для осадных войн.\n\n" ..
					   "При наведении на строку любого бафа, Вы увидите подсказку о скилле или предмете, который нужен для поддержания бафа. " ..
					   "Если подсказка не полна, а показывает только название предмета, это означает, что нужный предмет в сумке отсутствует.\n\n" ..
					   "Режим поверхность/подземелье/осадные войны так же можно переключить в контекстном меню кнопки миникарты аддона.";
		end;
		MLib.NoteDialog( NoteText, 160 );
	end;
end;

function MB.events.RenewBuffs( control, status )
	if( status == nil )then status = MB_STATE_NORMAL; end;
	local stItems = {};
	local stIcons = {};
	local stMouseOver = {};
	local stSelected = {};
	for n = 1, #MB.Actions[ status ]do
		stItems[ #stItems + 1 ] = MB.Actions[ status ][ n ].name;
		stIcons[ #stIcons + 1 ] = MB.Actions[ status ][ n ].icon;
		if( MB.Specifics[ status ][ n ] == nil )then MB.Specifics[ status ][ n ] = {}; end;
		stSelected[ #stSelected + 1 ] = #MB.Specifics[ status ][ n ] > 0;
		
		if( MB.Actions[ status ][ n ].skill )then
			
			stMouseOver[ #stMouseOver + 1 ] = function( this )
				GameTooltip:SetOwner( this, "ANCHOR_LEFT", 4, 0 );
				GameTooltip:SetSkillItem( MB.Actions[ status ][ n ].page, MB.Actions[ status ][ n ].index );
				GameTooltip:Show();
			end;
			
		else
			local ind = #stMouseOver + 1;
			for num = 1, 180 do
				if( MLib.itemID( GetBagItemLink( GetBagItemInfo( num ) ) ) == MB.Actions[ status ][ n ].guid )then
					stMouseOver[ ind ] = function( this )
						GameTooltip:SetOwner( this, "ANCHOR_LEFT", 4, 0 );
						GameTooltip:SetBagItem( GetBagItemInfo( num ) );
						GameTooltip:Show();
					end;
				end;
			end;
			if( stMouseOver[ ind ] == nil )then
				stMouseOver[ ind ] = function( this )
					GameTooltip:SetOwner( this, "ANCHOR_LEFT", 4, 0 );
					GameTooltip:SetText( MB.Actions[ status ][ n ].name );
					GameTooltip:Show();
				end;
			end;

		end;
	end;
	control.Items = stItems;
	control.Icons = stIcons;
	control.MouseOver = stMouseOver;
	control.Selected = stSelected;
end;

function MB.events.ConfigOnShow(this)
	_G[ this:GetName() .. "Title" ]:SetText( MB.Name .. " " .. MB.Version );
	MB.events.PlaceAbilityFrame();
	
	local page = this:GetName() .. "Page1";
		_G[ page .. "Exceptions" ].Items = MB.Exceptions;
		_G[ page .. "Exceptions" ].OnChange = function(this)
			if( this.ItemIndex ~= -1 )then
				_G[ this:GetParent():GetName() .. "Del" ]:Enable();
			else
				_G[ this:GetParent():GetName() .. "Del" ]:Disable();
			end;
		end;
		
		_G[ page .. "lbl1" ]:SetText( "Новое исключение" );
		local stItems = {};
		for n = 1, 10 do
			local _,_,_name = PartnerFrame_GetPartnerInfo( 0, n );
			if( _name ~= "" )then
				stItems[ #stItems + 1 ] = _name:match( "(.+) %(.+%)" );
			end;
		end;
		_G[ page .. "BuffName" ].Items = stItems;
		_G[ page .. "Ok" ]:SetText( "Добавить" );
		_G[ page .. "Del" ]:SetText( "Удалить" );
		_G[ page .. "Del" ]:Disable();
		
		_G[ page .. "AutoRun" ].Items = {
			[1] = "Отключен",
			[2] = "Ctrl + \"Бег вперед\"",
			[3] = "Shift + \"Бег вперед\"",
			[4] = "Alt + \"Бег вперед\"",
		};
		_G[ page .. "AutoRun" ].ItemIndex = MBVariables.AutoRun;
		_G[ page .. "AutoRun" ].OnChange = function( this )
			if( not MBConfigFrame:IsVisible() )then return nil; end;
			MBVariables.AutoRun = this.ItemIndex;
		end;
		_G[ page .. "AutoRunTitle" ]:SetText( "Включить автобег при нажатии:" );
		
	
	page = this:GetName() .. "Page2";
		_G[ page .. "lbl1" ]:SetText( "Добавить новый" );
		_G[ page .. "BuffNameTitle" ]:SetText( "Введите отслеживаемый баф" );
		_G[ page .. "BuffName" ].Items = MB.tools.GetMyBuffs();
		_G[ page .. "BuffName" ].FullSearch = true;
		_G[ page .. "Ok" ]:SetText( "Добавить" );
		_G[ page .. "Del" ]:SetText( "Удалить" );
		_G[ page .. "Del" ]:Disable();
		_G[ page .. "Spec" ]:SetText( "Условия" );
		_G[ page .. "Spec" ]:Disable();
		MB.events.RenewBuffs( _G[ page .. "Buffs" ] );
		_G[ page .. "Buffs" ].OnChange = function( this )
			if( this.ItemIndex == -1 )then
				_G[ this:GetParent():GetName() .. "Del" ]:Disable();
				_G[ this:GetParent():GetName() .. "Spec" ]:Disable();
			else
				_G[ this:GetParent():GetName() .. "Del" ]:Enable();
				_G[ this:GetParent():GetName() .. "Spec" ]:Enable();
			end;
		end;
		
	
	page = this:GetName() .. "Page3";
		_G[ page .. "lbl1" ]:SetText( "Добавить новый" );
		_G[ page .. "BuffNameTitle" ]:SetText( "Введите отслеживаемый баф" );
		_G[ page .. "BuffName" ].Items = MB.tools.GetMyBuffs();
		_G[ page .. "BuffName" ].FullSearch = true;
		_G[ page .. "Ok" ]:SetText( "Добавить" );
		_G[ page .. "Del" ]:SetText( "Удалить" );
		_G[ page .. "Del" ]:Disable();
		_G[ page .. "Spec" ]:SetText( "Условия" );
		_G[ page .. "Spec" ]:Disable();
		MB.events.RenewBuffs( _G[ page .. "Buffs" ], MB_STATE_DUNGEON );
		_G[ page .. "Buffs" ].OnChange = function( this )
			if( this.ItemIndex == -1 )then
				_G[ this:GetParent():GetName() .. "Del" ]:Disable();
				_G[ this:GetParent():GetName() .. "Spec" ]:Disable();
			else
				_G[ this:GetParent():GetName() .. "Del" ]:Enable();
				_G[ this:GetParent():GetName() .. "Spec" ]:Enable();
			end;
		end;
		
	
	page = this:GetName() .. "Page4";
		_G[ page .. "lbl1" ]:SetText( "Добавить новый" );
		_G[ page .. "BuffNameTitle" ]:SetText( "Введите отслеживаемый баф" );
		_G[ page .. "BuffName" ].Items = MB.tools.GetMyBuffs();
		_G[ page .. "BuffName" ].FullSearch = true;
		_G[ page .. "Ok" ]:SetText( "Добавить" );
		_G[ page .. "Del" ]:SetText( "Удалить" );
		_G[ page .. "Del" ]:Disable();
		_G[ page .. "Spec" ]:SetText( "Условия" );
		_G[ page .. "Spec" ]:Disable();
		MB.events.RenewBuffs( _G[ page .. "Buffs" ], MB_STATE_GUILDWAR );
		_G[ page .. "Buffs" ].OnChange = function( this )
			if( this.ItemIndex == -1 )then
				_G[ this:GetParent():GetName() .. "Del" ]:Disable();
				_G[ this:GetParent():GetName() .. "Spec" ]:Disable();
			else
				_G[ this:GetParent():GetName() .. "Del" ]:Enable();
				_G[ this:GetParent():GetName() .. "Spec" ]:Enable();
			end;
		end;
		
end;

function MB.events.OnReceiveDrag(this)
	this.NewBuff = nil;
	if( CursorItemType() ~= "bag" )and( CursorItemType() ~= "skill" )then return nil; end;
	
	if( CursorItemType() == "bag" )then
		
		local index = GetCursorItemInfo();
		local num = -1;
		for n = 1, 180 do
			if( _G[ "BagItemButton" .. n ].index == index )then
				BagItemButton_OnClick( _G[ "BagItemButton" .. n ], "LBUTTON", 1 );
				num = n;
			end;
		end;

		local _, icon, name, itemCount, locked, quality = GetBagItemInfo( num );
		local link = GetBagItemLink( index, false );

		this.NewBuff = {
			["skill"] = false,
			["name"] = name,
			["icon"] = icon,
			["guid"] = MLib.itemID( link ),
		};
		
		_G[ this:GetName() .. "Icon" ]:SetTexture( icon );
		local r, g, b = MLib.ColorHex2Dec( MLib.Qualities[ quality ]:sub( 5, 10 ) );
		_G[ this:GetName() .. "Quality" ]:Show();
		_G[ this:GetName() .. "Quality" ]:SetColor( r, g, b );
		_G[ this:GetName() .. "Text" ]:SetText( name );

	else
		-- Drop skill
		local name, _, icon, _, _type, rank, _, upgradeCost, isSkillable, isAvailable = GetSkillDetail( MB.hooks.SkillPage, MB.hooks.SkillIndex );
		DeleteCursorItem();
		this.NewBuff = {
			["skill"] = true,
			["name"] = name,
			["icon"] = icon,
			["page"] = MB.hooks.SkillPage,
			["index"] = MB.hooks.SkillIndex,
		};
		
		_G[ this:GetName() .. "Icon" ]:SetTexture( icon );
		local r, g, b = MLib.ColorHex2Dec( MLib.Qualities[ 100 ]:sub( 5, 10 ) );
		_G[ this:GetName() .. "Quality" ]:Show();
		_G[ this:GetName() .. "Quality" ]:SetColor( r, g, b );
		_G[ this:GetName() .. "Text" ]:SetText( name );
	end;
end;

function MB.events.ContainerHint(this)
	MLib.TT.Init( this, "Новый бафф", 300, "ANCHOR_BOTTOMRIGHT", 0, 0 );
	MLib.TT.Line( "Перетащите сюда скилл или предмет инвентаря, чтобы использовать его при отслеживании нового бафа" );
end;

function MB.events.NormOkOnClick(this)
	local _parent = this:GetParent():GetName();
	if( _G[ _parent .. "BuffName" ]:GetText() == "" )then
		MLib.MsgDialog( "Заполните название отслеживаемого бафа" );
		return nil;
	end;
	
	if( _G[ _parent .. "Container" ].NewBuff == nil )then
		MLib.MsgDialog( "Укажите, что следует использовать" );
		return nil;
	end;
	
	for n = 1, #MB.Actions[ MB_STATE_NORMAL ] do
		if( MB.Actions[ MB_STATE_NORMAL ][ n ][ "buff" ] == _G[ _parent .. "BuffName" ]:GetText() )then
			MLib.MsgDialog( "Этот баф уже отслеживается" );
			return nil;
		end;
	end;
	
	local order = 1;
	for n = 1, #MB.Actions[ MB_STATE_NORMAL ] do
		if( MB.Actions[ MB_STATE_NORMAL ][ n ][ "order" ] >= order )then
			order = MB.Actions[ MB_STATE_NORMAL ][ n ][ "order" ] + 1;
		end;
	end;
	
	local stNew = {
		["buff"] = _G[ _parent .. "BuffName" ]:GetText(),
		["order"] = order,
	};

	for key, value in pairs( _G[ _parent .. "Container" ].NewBuff )do
		stNew[ key ] = value;
	end;
	
	local count = #MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_NORMAL ];
	MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_NORMAL ][ count + 1 ] = stNew;
	MB.Actions[ MB_STATE_NORMAL ] = MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_NORMAL ];
	table.sort( MB.Actions[ MB_STATE_NORMAL ], function( a, b ) return a.order < b.order; end );
	
	MB.events.RenewBuffs( _G[ _parent .. "Buffs" ] );
	
	_G[ _parent .. "Container" ].NewBuff = nil;
	_G[ _parent .. "BuffName" ]:SetText( "" );
	_G[ _parent .. "ContainerIcon" ]:SetTexture( "" );
	_G[ _parent .. "ContainerQuality" ]:Hide();
	_G[ _parent .. "ContainerText" ]:SetText( name );
	_G[ _parent .. "BuffName" ]:SetFocus();
end;

function MB.events.NormDelOnClick(this)
	local stItems = {};
	local list = _G[ this:GetParent():GetName() .. "Buffs" ];
	for n = 1, #MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_NORMAL ]do
		if( MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_NORMAL ][ n ].name ~= list.Items[ list.ItemIndex ] )then
			stItems[ #stItems + 1 ] = MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_NORMAL ][ n ];
		end;
	end;
	MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_NORMAL ] = stItems;
	MB.Actions[ MB_STATE_NORMAL ] = stItems;
	MB.events.RenewBuffs( _G[ this:GetParent():GetName() .. "Buffs" ] );
	_G[ this:GetParent():GetName() .. "Buffs" ].ItemIndex = -1;
end;

function MB.events.ExceptOkOnClick(this)
	local _parent = this:GetParent():GetName();
	if( _G[ _parent .. "BuffName" ]:GetText() == "" )then
		MLib.MsgDialog( "Заполните название отслеживаемого бафа" );
		return nil;
	end;

	for n = 1, #MBVariables.Exceptions[ MB.CurrentSet ]do
		if( MBVariables.Exceptions[ MB.CurrentSet ][ n ] == _G[ _parent .. "BuffName" ]:GetText() )then
			MLib.MsgDialog( "Такое исключение уже существует" );
			return nil;
		end;
	end;
	
	MBVariables.Exceptions[ MB.CurrentSet ][ #MBVariables.Exceptions[ MB.CurrentSet ] + 1 ] = _G[ _parent .. "BuffName" ]:GetText();
	MB.Exceptions = MBVariables.Exceptions[ MB.CurrentSet ];
	_G[ _parent .. "Exceptions" ].Items = MB.Exceptions;
	_G[ _parent .. "BuffName" ]:SetText( "" );
	_G[ _parent .. "BuffName" ]:SetFocus();
end;

function MB.events.ExceptDelOnClick(this)
	local stItems = {};
	local list = _G[ this:GetParent():GetName() .. "Exceptions" ];
	for n = 1, #MBVariables.Exceptions[ MB.CurrentSet ]do
		if( MBVariables.Exceptions[ MB.CurrentSet ][ n ] ~= list.Items[ list.ItemIndex ] )then
			stItems[ #stItems + 1 ] = MBVariables.Exceptions[ MB.CurrentSet ][ n ];
		end;
	end;
	MBVariables.Exceptions[ MB.CurrentSet ] = stItems;
	MB.Exceptions = MBVariables.Exceptions[ MB.CurrentSet ];
	_G[ this:GetParent():GetName() .. "Exceptions" ].Items = MB.Exceptions;
	_G[ this:GetParent():GetName() .. "Exceptions" ].ItemIndex = -1;
end;

function MB.events.DungOkOnClick(this)
	local _parent = this:GetParent():GetName();
	if( _G[ _parent .. "BuffName" ]:GetText() == "" )then
		MLib.MsgDialog( "Заполните название отслеживаемого бафа" );
		return nil;
	end;
	
	if( _G[ _parent .. "Container" ].NewBuff == nil )then
		MLib.MsgDialog( "Укажите, что следует использовать" );
		return nil;
	end;
	
	for n = 1, #MB.Actions[ MB_STATE_DUNGEON ] do
		if( MB.Actions[ MB_STATE_DUNGEON ][ n ][ "buff" ] == _G[ _parent .. "BuffName" ]:GetText() )then
			MLib.MsgDialog( "Этот баф уже отслеживается" );
			return nil;
		end;
	end;
	
	local order = 1;
	for n = 1, #MB.Actions[ MB_STATE_DUNGEON ] do
		if( MB.Actions[ MB_STATE_DUNGEON ][ n ][ "order" ] >= order )then
			order = MB.Actions[ MB_STATE_DUNGEON ][ n ][ "order" ] + 1;
		end;
	end;
	
	local stNew = {
		["buff"] = _G[ _parent .. "BuffName" ]:GetText(),
		["order"] = order,
	};

	for key, value in pairs( _G[ _parent .. "Container" ].NewBuff )do
		stNew[ key ] = value;
	end;
	
	local count = #MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_DUNGEON ];
	MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_DUNGEON ][ count + 1 ] = stNew;
	MB.Actions[ MB_STATE_DUNGEON ] = MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_DUNGEON ];
	table.sort( MB.Actions[ MB_STATE_DUNGEON ], function( a, b ) return a.order < b.order; end );
	
	MB.events.RenewBuffs( _G[ _parent .. "Buffs" ], MB_STATE_DUNGEON );
	
	_G[ _parent .. "Container" ].NewBuff = nil;
	_G[ _parent .. "BuffName" ]:SetText( "" );
	_G[ _parent .. "ContainerIcon" ]:SetTexture( "" );
	_G[ _parent .. "ContainerQuality" ]:Hide();
	_G[ _parent .. "ContainerText" ]:SetText( name );
	_G[ _parent .. "BuffName" ]:SetFocus();
end;

function MB.events.DungDelOnClick(this)
	local stItems = {};
	local list = _G[ this:GetParent():GetName() .. "Buffs" ];
	for n = 1, #MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_DUNGEON ]do
		if( MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_DUNGEON ][ n ].name ~= list.Items[ list.ItemIndex ] )then
			stItems[ #stItems + 1 ] = MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_DUNGEON ][ n ];
		end;
	end;
	MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_DUNGEON ] = stItems;
	MB.Actions[ MB_STATE_DUNGEON ] = stItems;
	MB.events.RenewBuffs( _G[ this:GetParent():GetName() .. "Buffs" ], MB_STATE_DUNGEON );
	_G[ this:GetParent():GetName() .. "Buffs" ].ItemIndex = -1;
end;

function MB.events.GuildOkOnClick(this)
	local _parent = this:GetParent():GetName();
	if( _G[ _parent .. "BuffName" ]:GetText() == "" )then
		MLib.MsgDialog( "Заполните название отслеживаемого бафа" );
		return nil;
	end;
	
	if( _G[ _parent .. "Container" ].NewBuff == nil )then
		MLib.MsgDialog( "Укажите, что следует использовать" );
		return nil;
	end;
	
	for n = 1, #MB.Actions[ MB_STATE_GUILDWAR ] do
		if( MB.Actions[ MB_STATE_GUILDWAR ][ n ][ "buff" ] == _G[ _parent .. "BuffName" ]:GetText() )then
			MLib.MsgDialog( "Этот баф уже отслеживается" );
			return nil;
		end;
	end;
	
	local order = 1;
	for n = 1, #MB.Actions[ MB_STATE_GUILDWAR ] do
		if( MB.Actions[ MB_STATE_GUILDWAR ][ n ][ "order" ] >= order )then
			order = MB.Actions[ MB_STATE_GUILDWAR ][ n ][ "order" ] + 1;
		end;
	end;
	
	local stNew = {
		["buff"] = _G[ _parent .. "BuffName" ]:GetText(),
		["order"] = order,
	};

	for key, value in pairs( _G[ _parent .. "Container" ].NewBuff )do
		stNew[ key ] = value;
	end;
	
	local count = #MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_GUILDWAR ];
	MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_GUILDWAR ][ count + 1 ] = stNew;
	MB.Actions[ MB_STATE_GUILDWAR ] = MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_GUILDWAR ];
	table.sort( MB.Actions[ MB_STATE_GUILDWAR ], function( a, b ) return a.order < b.order; end );
	
	MB.events.RenewBuffs( _G[ _parent .. "Buffs" ], MB_STATE_GUILDWAR );
	
	_G[ _parent .. "Container" ].NewBuff = nil;
	_G[ _parent .. "BuffName" ]:SetText( "" );
	_G[ _parent .. "ContainerIcon" ]:SetTexture( "" );
	_G[ _parent .. "ContainerQuality" ]:Hide();
	_G[ _parent .. "ContainerText" ]:SetText( name );
	_G[ _parent .. "BuffName" ]:SetFocus();
end;

function MB.events.GuildDelOnClick(this)
	local stItems = {};
	local list = _G[ this:GetParent():GetName() .. "Buffs" ];
	for n = 1, #MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_GUILDWAR ]do
		if( MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_GUILDWAR ][ n ].name ~= list.Items[ list.ItemIndex ] )then
			stItems[ #stItems + 1 ] = MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_GUILDWAR ][ n ];
		end;
	end;
	MBVariables.Actions[ MB.CurrentSet ][ MB_STATE_GUILDWAR ] = stItems;
	MB.Actions[ MB_STATE_GUILDWAR ] = stItems;
	MB.events.RenewBuffs( _G[ this:GetParent():GetName() .. "Buffs" ], MB_STATE_GUILDWAR );
	_G[ this:GetParent():GetName() .. "Buffs" ].ItemIndex = -1;
end;

function MB.events.TimeOnValueChanged(this)
	GCF_Slider_OnValueChanged( this );
	local units = "секунд";
	if( this:GetValue() == 1 )then units = "секунда"; end;
	if( this:GetValue() > 1 )and( this:GetValue() < 5 )then units = "секунды"; end;
	_G[ this:GetName() .. "Value" ]:SetText( tostring( this:GetValue() ) .. " " .. units );
	if( not MBConfigFrame:IsVisible() )then return nil; end;
	MBVariables.BuffWarning = this:GetValue();
end;

function MB.events.SpecOnShow(this)
	_G[ this:GetName() .. "Spec1Title" ]:SetText( "Условие #1" );
	_G[ this:GetName() .. "Spec2Title" ]:SetText( "Условие #2" );
	_G[ this:GetName() .. "Spec3Title" ]:SetText( "Условие #3" );
	_G[ this:GetName() .. "Spec4Title" ]:SetText( "Условие #4" );
	_G[ this:GetName() .. "Spec5Title" ]:SetText( "Условие #5" );
	
	local stItems = { "Нет условия", "Есть баф на игроке", "Нет бафа на игроке", "ХП игрока меньше (в %)", "MP игрока меньше (в %)", "SP игрока меньше (в %)" };
	for n = 1, 5 do
		_G[ this:GetName() .. "Spec" .. n ].Items = stItems;
		_G[ this:GetName() .. "Spec" .. n ].ItemIndex = 1;
		_G[ this:GetName() .. "Buff" .. n ].Items = MB.tools.GetMyBuffs();
	end;
	if( MBVariables.Specifics[ MB.CurrentSet ][ MBSpecFrame.Status ][ MBSpecFrame.ItemIndex ] == nil )then MBVariables.Specifics[ MB.CurrentSet ][ MBSpecFrame.Status ][ MBSpecFrame.ItemIndex ] = {}; end;
	for n = 1, 5 do
		if( MBVariables.Specifics[ MB.CurrentSet ][ MBSpecFrame.Status ][ MBSpecFrame.ItemIndex ][ n ] ~= nil )then
			_G[ this:GetName() .. "Spec" .. n ].ItemIndex = MBVariables.Specifics[ MB.CurrentSet ][ MBSpecFrame.Status ][ MBSpecFrame.ItemIndex ][ n ].spec;
			_G[ this:GetName() .. "Buff" .. n ]:SetText( MBVariables.Specifics[ MB.CurrentSet ][ MBSpecFrame.Status ][ MBSpecFrame.ItemIndex ][ n ].buff );
		end;
	end;
	
	_G[ this:GetName() .. "Ok" ]:SetText( "Сохранить" );

	MLExtraModal:Show();
end;

function MB.events.SpecOnHide(this)
	MLExtraModal:Hide();
end;

function MB.events.NormSpecOnClick(this)
	MBSpecFrame.Status = MB_STATE_NORMAL;
	MBSpecFrame.ItemIndex = MBConfigFramePage2Buffs.ItemIndex;
	local tab = "На поверхности";
	if( MBConfigFrame.TabIndex == 3 )then
		MBSpecFrame.Status = MB_STATE_DUNGEON;
		MBSpecFrame.ItemIndex = MBConfigFramePage3Buffs.ItemIndex;
		tab = "В подземелье";
	end;
	if( MBConfigFrame.TabIndex == 4 )then
		MBSpecFrame.Status = MB_STATE_GUILDWAR;
		MBSpecFrame.ItemIndex = MBConfigFramePage4Buffs.ItemIndex;
		tab = "На осаде";
	end;
	MBSpecFrameTitle:SetText( "Buff [" .. tab .. "]: " .. MB.Actions[ MBSpecFrame.Status ][ MBSpecFrame.ItemIndex ].name );
	MBSpecFrame:Show();
end;

function MB.events.SpecOkOnClick(this)
	for n = 1, 5 do
		local cbb = _G[ this:GetParent():GetName() .. "Spec" .. n ];
		local edt = _G[ this:GetParent():GetName() .. "Buff" .. n ];
		if( cbb.ItemIndex > 1 )then
			MBVariables.Specifics[ MB.CurrentSet ][ MBSpecFrame.Status ][ MBSpecFrame.ItemIndex ][ n ] = {
				["spec"] = cbb.ItemIndex,
				["buff"] = edt:GetText(),
			};
		else
			MBVariables.Specifics[ MB.CurrentSet ][ MBSpecFrame.Status ][ MBSpecFrame.ItemIndex ][ n ] = nil;
		end;
	end;
	this:GetParent():Hide();
end;

function MB.events.AbilityAnchorHint( this )
	this:SetAlpha(1);
	MLib.TT.Init( this, MB.Name .. " " .. MB.Version, 300, "ANCHOR_BOTTOMRIGHT", 0, 0 );
	MLib.TT.Line( "Панель статов" );
	MLib.TT.Space();
	MLib.TT.Line( "Shift + Правая кнопка мыши для перетаскивания", 0, 0.75, 0.95 );
end;

function MB.events.AbilityAnchorMouseDown( this, key )
	if( not MLib.ControlsDown( false ) )and( key == "RBUTTON" )then
		this:GetParent():StartMoving( "TOPLEFT" );
		this.IsMoving = true;
	end;
end;

function MB.events.AbilityAnchorMouseUp( this )
	if( not this.IsMoving )then return nil; end;
	this:GetParent():StopMovingOrSizing();
	MBVariables.AbilityFramePosition.X, MBVariables.AbilityFramePosition.Y = this:GetParent():GetPos();
	SaveVariables( "MBVariables" );
end;

function MB.events.AbilityUpdate( this, elapsedTime )
	if( not MB.Inited )then return nil; end;
	if( not MBVariables.AbilityFrame )then
		MBAbilities:Hide();
		return nil;
	end;
	if( this.Time == nil )then this.Time = 0; end;
	this.Time = this.Time + elapsedTime;
	if( this.Time < 0.5 )then return nil; end;
	this.Time = 0;


	local cbb = _G[ "MBConfigFrame" .. "Page1" .. "Abilities" .. "FontSize" ];
	if( cbb.Items == nil )then return nil; end;
	local size = cbb.Items[ cbb.ItemIndex ];
	for n = 1, 22 do
		_G[ "MBAbilities" .. n .. "Name" ]:SetFontSize( size );
		_G[ "MBAbilities" .. n .. "Data" ]:SetFontSize( size - 1 );
		_G[ "MBAbilities" .. n .. "Name" ]:SetText( "" );
		_G[ "MBAbilities" .. n .. "Data" ]:SetText( "" );
		_G[ "MBAbilities" .. n ]:SetHeight( size + 2 );
	end;

	MBAbilities:Show();
	if( MB.Abilities == nil )then MB.Abilities = {}; end;
	local stAbilities = {};
	for n = 1, 9 do
		if( MB.Abilities[ n ] )then stAbilities[ #stAbilities + 1 ] = n; end;
	end;
	if( MB.Abilities[ 22 ] )then stAbilities[ #stAbilities + 1 ] = 22; end;
	if( MB.Abilities[ 24 ] )then stAbilities[ #stAbilities + 1 ] = 24; end;
	for n = 10, 21 do
		if( MB.Abilities[ n ] )then stAbilities[ #stAbilities + 1 ] = n; end;
	end;
	if( MB.Abilities[ 23 ] )then stAbilities[ #stAbilities + 1 ] = 23; end;
	local player = Role:new("player");
	for n = 1, 22 do
		if( n <= #stAbilities )then
			_G[ "MBAbilities" .. n ]:Show();
			local c = MB.AbilityColors[ stAbilities[ n ] ]
			_G[ "MBAbilities" .. n .. "Name" ]:SetColor( c[ 1 ], c[ 2 ], c[ 3 ] );
			_G[ "MBAbilities" .. n .. "Data" ]:SetColor( c[ 1 ], c[ 2 ], c[ 3 ] );

			_G[ "MBAbilities" .. n .. "Name" ]:SetText( MB.AbilityName[ stAbilities[ n ] ] );
			local data = player:Ability( stAbilities[ n ], MB.Abilities[ 99 ] );
			if( stAbilities[ n ] == 8 )or( stAbilities[ n ] == 12 )or( stAbilities[ n ] == 16 )then
				if( MB.Abilities[ 100 ] )then
					data = player:Ability( stAbilities[ n ], MB.Abilities[ 99 ], true );
				else
					data = data .. " (" .. player:Ability( stAbilities[ n ], MB.Abilities[ 99 ], true ) .. ")";
				end;
			end;
			_G[ "MBAbilities" .. n .. "Data" ]:SetText( data );
		else
			_G[ "MBAbilities" .. n ]:Hide();
		end;
	end;
end;

function MB.events.AbilityCBClick( this )
	MBVariables.Abilities[ MB.CurrentSet ][ this:GetID() ] = this:IsChecked();
	MB.Abilities = MBVariables.Abilities[ MB.CurrentSet ];
end;

-- /run dofile("interface/addons/mautobuff/code/events.lua");