MB.tools = {};

function MB.tools.LoadConfig()
	if( MBVariables.Actions == nil )then MBVariables.Actions = {}; end;
	if( MBVariables.Exceptions == nil )then MBVariables.Exceptions = {}; end;
	if( MBVariables.Specifics == nil )then MBVariables.Specifics = {}; end;
	if( MBVariables.Abilities == nil )then MBVariables.Abilities = {}; end;
	MB.Actions = {};
	MB.Exceptions = {};
	MB.Abilities = {};
	
	local name, class, subclass = UnitName( "player" ), UnitClassToken( "player" );
	if( name == nil )then return false; end;
	
	local index = name .. class .. subclass;
	MB.CurrentSet = index;
	local sIndex = MLib.MMPattern:format( name ) .. MLib.ChatColor .. " (" .. MLib.ColorizeClass( class ) .. MLib.ChatColor .. "/" .. MLib.ColorizeClass( subclass ) .. MLib.ChatColor .. ")";
	if( MBVariables.Actions[ index ] ~= nil )and( type( MBVariables.Actions[ index ] ) == "table" )then
		MB.Actions = MBVariables.Actions[ index ];
		MB.Message( "Загружена таблица действий для: " .. sIndex .. "." );
	else
		MBVariables.Actions[ index ] = {};
		MB.Actions = MBVariables.Actions[ index ];
		MB.Message( "Таблица действий для " .. sIndex .. " создана! Для заполнения воспользуйтесь интерфейсом аддона." );
	end;
	
	if( MBVariables.Exceptions[ index ] ~= nil )and( type( MBVariables.Exceptions[ index ] ) == "table" )then
		MB.Exceptions = MBVariables.Exceptions[ index ];
		MB.Message( "Загружена таблица исключений для: " .. sIndex .. "." );
	else
		MBVariables.Exceptions[ index ] = {};
		MB.Exceptions = MBVariables.Exceptions[ index ];
		MB.Message( "Таблица исключений для " .. sIndex .. " создана! Для заполнения воспользуйтесь интерфейсом аддона." );
	end;

	if( MBVariables.Specifics[ MB.CurrentSet ] == nil )then MBVariables.Specifics[ MB.CurrentSet ] = {}; end;
	if( MBVariables.Specifics[ index ][ MB_STATE_NORMAL ] == nil )then MBVariables.Specifics[ index ][ MB_STATE_NORMAL ] = {}; end;
	if( MBVariables.Specifics[ index ][ MB_STATE_DUNGEON ] == nil )then MBVariables.Specifics[ index ][ MB_STATE_DUNGEON ] = {}; end;
	if( MBVariables.Specifics[ index ][ MB_STATE_GUILDWAR ] == nil )then MBVariables.Specifics[ index ][ MB_STATE_GUILDWAR ] = {}; end;
	
	MB.Specifics = MBVariables.Specifics[ index ];
	
	if( MBVariables.Abilities == nil )then MBVariables.Abilities = {}; end;
	if( MBVariables.Abilities[ MB.CurrentSet ] == nil )then
		MBVariables.Abilities[ MB.CurrentSet ] = {
			[1]  = false,	-- Сила
			[2]  = false,	-- Ловкость
			[3]  = false,	-- Выносливость
			[4]  = false,	-- Интеллект
			[5]  = false,	-- Мудрость
			[6]  = false,	-- Физ. урон
			[7]  = false,	-- Физ. атака
			[8]  = false,	-- Физ. крит
			[9]  = false,	-- Меткость
			[10] = false,	-- Маг. урон
			[11] = false,	-- Маг. атака
			[12] = false,	-- Маг. крит
			[13] = false,	-- Бонус исцеления
			[14] = false,	-- Маг. меткость
			[15] = false,	-- Физ. защита
			[16] = false,	-- Шанс парирования
			[17] = false,	-- Уклонение
			[18] = false,	-- Защита от крита
			[19] = false,	-- Маг. защита
			[20] = false,	-- Сопротивление магии
			[21] = false,	-- Защита от маг крита
			[22] = false,	-- ДПС
			[23] = false,	-- Блок щитом
			[24] = false,	-- Скорость атаки
			[98] = false,	-- Полные названия
			[99] = false,	-- Дальний бой
			[100]= false,	-- Только проценты
		};
	end;
	MB.Abilities = MBVariables.Abilities[ MB.CurrentSet ];
	
	if( MB.Actions[ MB_STATE_NORMAL ] == nil )then MB.Actions[ MB_STATE_NORMAL ] = {}; end;
	if( MB.Actions[ MB_STATE_DUNGEON ] == nil )then MB.Actions[ MB_STATE_DUNGEON ] = {}; end;
	if( MB.Actions[ MB_STATE_GUILDWAR ] == nil )then MB.Actions[ MB_STATE_GUILDWAR ] = {}; end;
	table.sort( MB.Actions[ MB_STATE_NORMAL ], function( a, b ) return a["order"] < b["order"]; end );
	table.sort( MB.Actions[ MB_STATE_DUNGEON ], function( a, b ) return a["order"] < b["order"]; end );
	table.sort( MB.Actions[ MB_STATE_GUILDWAR ], function( a, b ) return a["order"] < b["order"]; end );
	
	if( MB.Exceptions == nil )then MB.Exceptions = {}; end;
end;

function MB.tools.GetMyBuffs()
	local stBuffs = {};
	for i=1,80 do
		local name, icon, count, buffID = UnitBuff("player",i);
		if( buffID ~= nil )then stBuffs[ #stBuffs + 1 ] = name; end;
	end;
	return stBuffs;
end;

function MB.tools.ShowMyBuffs()
	for i=1,80 do
		local name, icon, count, buffID = UnitBuff("player",i);
		if( buffID ~= nil )then MB.Message( "#" .. i .. " [" .. name .. "]: id=" .. buffID ); end;
	end;
end;

function MB.tools.IsBuffApply( buff, ignoreWarn )
	if( ignoreWarn == nil )then ignoreWarn = false; end;
	if( MBVariables.BuffWarning == nil )then MBVariables.BuffWarning = 10; end;
	for i=1,80 do
		local name, icon, count, buffID = UnitBuff( "player", i );
		if( buffID ~= nil )then 
			if( name == buff )then
				local dur = UnitBuffLeftTime( "player", i );
				if( dur ~= nil )then
					if( ignoreWarn )then
						return true;
					else
						if( dur - MBVariables.BuffWarning < 0 )then return false; end;
					end;
				end;
				return true;
			end;
		end;
	end;
	return false;
end;

function MB.tools.CheckSpec( state, num )
	local flag = true;
	
	for n = 1, 5 do
		if( MB.Specifics[ state ][ num ][ n ] ~= nil )then
			local cfg = MB.Specifics[ state ][ num ][ n ];
			local playerHP = math.floor( UnitHealth( "player" ) * 100 / UnitMaxHealth( "player" ) );
			local playerMP = math.floor( UnitMana( "player" ) * 100 / UnitMaxMana( "player" ) );
			local playerSP = math.floor( UnitSkill( "player" ) * 100 / UnitMaxSkill( "player" ) );
			if( cfg.spec == 2 )and( not MB.tools.IsBuffApply( cfg.buff, true ) )then flag = false; end;
			if( cfg.spec == 3 )and( MB.tools.IsBuffApply( cfg.buff, true ) )then flag = false; end;
			if( cfg.spec == 4 )and( playerHP >= tonumber( cfg.buff ) )then flag = false; end;
			if( cfg.spec == 5 )and( playerMP >= tonumber( cfg.buff ) )then flag = false; end;
			if( cfg.spec == 6 )and( playerSP >= tonumber( cfg.buff ) )then flag = false; end;
		end;
	end;
	
	return flag;
end;

function MB.tools.BuffStack( target, buffName )
	local n = 1;
	while( UnitBuff( target, n ) ~= nil )do
		local name, icon, count, ID = UnitBuff( target, n );
		if( name == buffName )then return count; end;
		n = n + 1;
	end;
	return 0;
end;

function MB.tools.Trigger()
	if( not MBVariables.Enabled )then return nil; end;
	if( MB.State == MB_STATE_SAFE )then return nil; end;
	for n = 1, #MB.Exceptions do
		if( MB.tools.IsBuffApply( MB.Exceptions[ n ] ) )then return nil; end;
	end;
	
--	for num, buffData in pairs( MB.Actions[ MB.State ] )do
	for num = 1, #MB.Actions[ MB.State ] do
		local buffData = MB.Actions[ MB.State ][ num ];
		if( not MB.tools.IsBuffApply( buffData.buff ) )and( MB.tools.CheckSpec( MB.State, num ) )then
			if( buffData.skill )then
				UseSkill( buffData.page, buffData.index );
				return nil;
			else
				for n = 1, 180 do
					if( MLib.itemID( GetBagItemLink( GetBagItemInfo( n ) ) ) == buffData.guid )then
						local maxCD, CurrentCD = GetBagItemCooldown ( GetBagItemInfo( n ) );
						if( CurrentCD < 1 )then
							BagItemButton_OnClick( _G[ "BagItemButton" .. n ], "RBUTTON", 1 );
							return nil;
						end;
					end;
				end;
			end;
		end;
	end;
end;

--[[ /run dofile("interface/addons/mautobuff/code/tools.lua"); ]]